2015-10-09  Ryan S. Arnold  <ryan.arnold@linaro.org>

	Make Linaro GCC Release 5.1-2015.08.

	gcc/
	* LINARO-VERSION: Update.

2015-08-14  Ryan S. Arnold  <ryan.arnold@linaro.org>

	gcc/
	* LINARO-VERSION: Bump version number, post release candidate.

2015-08-13  Ryan S. Arnold  <ryan.arnold@linaro.org>

	Make Linaro GCC Release Candidate 5.1-2015.08-rc1.

	gcc/
	* LINARO-VERSION: Update.

2015-06-23  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-23  Christophe Lyon  <christophe.lyon@linaro.org>

	* LINARO-VERSION: Bump version number, post release.

2015-06-19  Christophe Lyon  <christophe.lyon@linaro.org>

	Make Linaro GCC Snapshot 5.1-2015.06.

2015-06-19  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-19  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	* configure.ac: Add Linaro version string.
	* configure: Regenerate.

2015-06-18  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-18  Christophe Lyon  <christophe.lyon@linaro.org>

	Cherry-pick from linaro/gcc-4_9-branch r217544.

	gcc/
	2014-11-14  Yvan Roux  <yvan.roux@linaro.org>

	Add Linaro release macros (Linaro only patch.)

	* Makefile.in (LINAROVER, LINAROVER_C, LINAROVER_S): Define.
	(CFLAGS-cppbuiltin.o): Add LINAROVER macro definition.
	(cppbuiltin.o): Depend on $(LINAROVER).
	* cppbuiltin.c (parse_linarover): New.
	(define_GNUC__): Define __LINARO_RELEASE__ and __LINARO_SPIN__ macros.

2015-06-13  Christophe Lyon  <christophe.lyon@linaro.org>

	Merge branches/gcc-5-branch rev 224205.

2015-06-12  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222263.
	2015-04-21  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

	* config/aarch64/aarch64.md (*<NLOGICAL:optab>_one_cmplsidi3_ze):
	New pattern.
	(*xor_one_cmplsidi3_ze): Likewise.

2015-06-12  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222229.
	2015-04-20  Alan Lawrence  <alan.lawrence@arm.com>

	PR target/64134
	* config/aarch64/aarch64.c (aarch64_expand_vector_init): Load constant
	and overwrite variable parts if <= 1/2 the elements are variable.

	gcc/testsuite/
	Backport from trunk r222229.
	2015-04-20  Alan Lawrence  <alan.lawrence@arm.com>

	PR target/64134
	* gcc.target/aarch64/vec_init_1.c: New test.

2015-06-12  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222186.
	2015-04-17  Jakub Jelinek  <jakub@redhat.com>

	PR target/65689
	* genpreds.c (struct constraint_data): Add maybe_allows_reg and
	maybe_allows_mem bitfields.
	(maybe_allows_none_start, maybe_allows_none_end,
	maybe_allows_reg_start, maybe_allows_reg_end, maybe_allows_mem_start,
	maybe_allows_mem_end): New variables.
	(compute_maybe_allows): New function.
	(add_constraint): Use it to initialize maybe_allows_reg and
	maybe_allows_mem fields.
	(choose_enum_order): Sort the non-is_register/is_const_int/is_memory/
	is_address constraints such that those that allow neither mem nor
	reg come first, then those that only allow reg but not mem, then
	those that only allow mem but not reg, then the rest.
	(write_allows_reg_mem_function): New function.
	(write_tm_preds_h): Call it.
	* stmt.c (parse_output_constraint, parse_input_constraint): Use
	the generated insn_extra_constraint_allows_reg_mem function
	instead of always setting *allows_reg = true; *allows_mem = true;
	for unknown extra constraints.

	gcc/testsuite/
	Backport from trunk r222186.
	2015-04-17  Jakub Jelinek  <jakub@redhat.com>

	PR target/65689
	* gcc.target/aarch64/c-output-template-4.c: New test.

2015-06-12  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222143.
	2015-04-16  Renlin Li  <renlin.li@arm.com>

	* simplify-rtx.c (simplify_unary_operation_1): Fix a typo. Enable two
	simplifications for UNSIGNED_FLOAT.

	gcc/testsuite/
	Backport from trunk r222143.
	2015-04-16  Renlin Li  <renlin.li@arm.com>

	* gcc.target/aarch64/unsigned-unsignedfloat.c: New.
	* gcc.target/arm/unsigned-float.c: New.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/testsuite/
	Backport from trunk r222396.
	2015-04-24  Bin Cheng  <bin.cheng@arm.com>

	* gcc.target/arm/pr42172-1.c: Check str instead of ldr.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222359.
	2015-04-23  Matthew Wahab  <matthew.wahab@arm.com>

	* config/arm/arm.h (LEGITIMIZE_RELOAD_ADDRESS): Remove.
	(ARM_LEGITIMIZE_RELOAD_ADDRESS): Remove.
	(THUMB_LEGITIMIZE_RELOAD_ADDRESS): Remove.
	* config/arm/arm.c (arm_legimitimize_reload_address): Remove.
	(thumb_legimitimize_reload_address): Remove.
	* config/arm/arm-protos.h (arm_legimitimize_reload_address):
	Remove.
	(thumb_legimitimize_reload_address): Remove.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222357.
	* config/arm/arm.md (load_multiple): Reject operand 2 greater than
	MAX_LDM_STM_OPS.
	(store_multiple): Likewise.

	2015-04-23  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222356.
	2015-04-23  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

	* config/arm/arm-protos.h (struct tune_params): Add issue_rate field.
	* config/arm/arm.c (arm_slowmul_tune, arm_fastmul_tune,
	arm_strongarm_tune, arm_xscale_tune, arm_9e_tune, arm_v6t2_tune,
	arm_cortex_tune, arm_cortex_a8_tune, arm_cortex_a7_tune,
	arm_cortex_a15_tune, arm_cortex_a53_tune, arm_cortex_a57_tune,
	arm_cortex_a9_tune, arm_cortex_a12_tune, arm_v7m_tune, arm_v6m_tune,
	arm_fa726te_tune arm_cortex_a5_tune, arm_xgene1_tune):
	Specify issue_rate value.
	(arm_issue_rate): Look up issue rate from tuning structs. Remove
	large switch statement.
	(arm_marvell_pj4_tune): New struct.
	* config/arm/arm-cores.def (marvell-pj4): Use arm_marvell_pj4_tune
	struct.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222350.
	2015-04-23  Kugan Vivekanandarajah  <kuganv@linaro.org>

	* ira-costs.c (record_operand_costs): Fix typo (remove redundant code).

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	libstdc++/
	Backport from trunk r222324.
	2015-04-22  Renlin Li  <renlin.li@arm.com>

	* testsuite/lib/dg-options.exp (dg-require-thread-fence): New.
	* testsuite/lib/libstdc++.exp (check_v3_target_thread_fence): New.
	* testsuite/29_atomics/atomic_flag/clear/1.cc: Use it.
	* testsuite/29_atomics/atomic_flag/test_and_set/explicit.cc: Likewise.
	* testsuite/29_atomics/atomic_flag/test_and_set/implicit.cc: Likewise.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222260.
	2015-04-21  Thomas Preud'homme  <thomas.preudhomme@arm.com>

	* df-core.c (df_finish_pass): Iterate over df->problems_by_index[] and
	use df_remove_problem rather than manually removing problems, leaving
	holes in df->problems_in_order[].

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222258.
	2015-04-21  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

	* common/config/aarch64/aarch64-common.c (AARCH64_CPU_NAME_LENGTH):
	Increase to 128.
	(aarch64_rewrite_selected_cpu): Do not chop off extensions starting
	at '.'.  Assert that there's enough space for everything.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222234.
	2015-04-20  Alan Lawrence  <alan.lawrence@arm.com>

	* config/aarch64/aarch64.c (aarch64_simd_emit_pair_result_insn): Delete.
	* config/aarch64/aarch64-protos.h (aarch64_simd_emit_pair_result_insn):
	Delete.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222177.
	2015-04-17  Alan Lawrence  <alan.lawrence@arm.com>

	* config/aarch64/arm_neon.h (vdup_n_f32): Remove forward declaration.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/testsuite/
	Backport from trunk r222148.
	2015-04-16  Alan Lawrence  <alan.lawrence@arm.com>

	* gcc.target/aarch64/vldN_lane_1.c: Correct dup->lane in comments.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222120.
	2015-04-14  Matthew Wahab  <matthew.wahab@arm.com>

	* doc/extend.texi (__sync Builtins): Simplify some text.  Update
	details about the implementation.  Make clear preference for
	__atomic builtins.  Reduce possibility of future change.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222101.
	2015-04-14  Yvan Roux  <yvan.roux@linaro.org>

	PR target/65729
	* lra-constraints.c (prohibited_class_reg_set_mode_p): Restore and fix
	the assertiion.

	gcc/testsuite/
	Backport from trunk r222101.
	2015-04-14  Yvan Roux  <yvan.roux@linaro.org>

	PR target/65729
	* gcc.target/arm/pr65729.c: New test.

	Backport from trunk r222228.
	2015-04-20  Yvan Roux  <yvan.roux@linaro.org>

	* gcc.target/arm/pr65729.c: Restrict to hard float ABI compliant
	targets.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/testsuite/
	Backport from trunk r224312.
	2015-06-10  James Greenhalgh  <james.greenhalgh@arm.com>

	* gcc.target/arm/pr65710.c: Do not override -mfloat-abi directives
	passed by the testsuite driver.

	Backport from trunk r222393.
	2015-04-24  Terry Guo  <terry.guo@arm.com>

	* gcc.target/arm/pr65710.c: Update the options.

	Backport from trunk r222037.
	2015-04-13  Terry Guo  <terry.guo@arm.com>

	PR target/65710
	* gcc.target/arm/pr65710.c: New.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222379.
	2015-04-23  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

	* config/arm/iterators.md (GTGE, GTUGEU, COMPARISONS): New code
	iterators.
	(cmp_op, cmp_type): New code attributes.
	(NEON_VCMP, NEON_VACMP): New int iterators.
	(cmp_op_unsp): New int attribute.
	* config/arm/neon.md (neon_vc<cmp_op><mode>): New define_expand.
	(neon_vceq<mode>): Delete.
	(neon_vc<cmp_op><mode>_insn): New pattern.
	(neon_vc<cmp_op_unsp><mode>_insn_unspec): Likewise.
	(neon_vcgeu<mode>): Delete.
	(neon_vcle<mode>): Likewise.
	(neon_vclt<mode>: Likewise.
	(neon_vcage<mode>): Likewise.
	(neon_vcagt<mode>): Likewise.
	(neon_vca<cmp_op><mode>): New define_expand.
	(neon_vca<cmp_op><mode>_insn): New pattern.
	(neon_vca<cmp_op_unsp><mode>_insn_unspec): Likewise.

	gcc/testsuite/
	Backport from trunk r222379.
	2015-04-23  Kyrylo Tkachov  <kyrylo.tkachov@arm.com>

	* gcc.target/arm/neon/pr51534.c: Update vcg* scan-assembly patterns
	to look for vcl* where appropriate.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	gcc/
	Backport from trunk r222092.
	2015-04-14  Alan Lawrence  <alan.lawrence@arm.com>

	* config/aarch64/arm_neon.h (vst1_lane_f32, vst1_lane_f64,
	vst1_lane_p8, vst1_lane_p16, vst1_lane_s8, vst1_lane_s16,
	vst1_lane_s32, vst1_lane_s64, vst1_lane_u8, vst1_lane_u16,
	vst1_lane_u32, vst1_lane_u64, vst1q_lane_f32, vst1q_lane_f64,
	vst1q_lane_p8, vst1q_lane_p16, vst1q_lane_s8, vst1q_lane_s16,
	vst1q_lane_s32, vst1q_lane_s64, vst1q_lane_u8, vst1q_lane_u16,
	vst1q_lane_u32, vst1q_lane_u64): Reimplement with pointer dereference
	and __aarch64_vget_lane_any.

2015-06-11  Christophe Lyon  <christophe.lyon@linaro.org>

	2015-06-03  Christophe Lyon  <christophe.lyon@linaro.org>

	Backport from trunk r222306.
	gcc/
	2015-04-22  Hale Wang  <hale.wang@arm.com>
	    Terry Guo  <terry.guo@arm.com>

	PR rtl-optimization/64818
	* combine.c (can_combine_p): Don't combine user-specified
	register if it is in an asm input.

	gcc/testsuite/
	2015-04-22  Hale Wang  <hale.wang@arm.com>
	    Terry Guo  <terry.guo@arm.com>

	PR rtl-optimization/64818
	* gcc.target/arm/pr64818.c: New test.

2015-06-11  Yvan Roux  <yvan.roux@linaro.org>

	gcc/testsuite/
	2015-05-21  Yvan Roux  <yvan.roux@linaro.org>

	Backport from trunk r222083.
	2015-04-14  Yvan Roux  <yvan.roux@linaro.org>

	PR target/65648
	* gcc.c-torture/execute/pr65648.c: New test.
